/* GCC */
#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;

int gcd(int a , int b)
{
    return b ? gcd(b , a % b) : a;
}

struct frac
{
    int a , b;
    frac () : a(0) , b(1) {};
    frac (int _a) : a(_a) , b(1) {};
    frac (int _a , int _b) : a(_a) , b(_b)
    {
        if ( b == 0 ) b = 1;
        if ( b < 0 ) a *= -1 , b *= -1;
        int div = gcd(abs(a) , abs(b));
        a /= div;
        b /= div;
    };
};

frac operator +(frac p , frac q)
{
    return frac(p.a * q.b + p.b * q.a , p.b * q.b);
}

frac operator -(frac p , frac q)
{
    return frac(p.a * q.b - p.b * q.a , p.b * q.b);
}

frac operator *(frac p , frac q)
{
    return frac(p.a * q.a , p.b * q.b);
}

frac operator /(frac p , frac q)
{
    return frac(p.a * q.b , p.b * q.a);
}

bool operator ==(frac p , frac q)
{
    return p.a * q.b == p.b * q.a;
}

bool operator >(frac p , frac q)
{
    return p.a * q.b > p.b * q.a;
}

void print(frac x)
{
    if ( x.b == 1 )
        printf("%d",x.a);
    else
        printf("%d/%d",x.a,x.b);
}

struct point
{
    frac x , y;
    point(){};
    point(frac _X , frac _Y) : x(_X) , y(_Y){};
};

struct line
{
    frac A , B , C;
    line(){};
    line(point pt1 , point pt2)
    {
        A = pt1.y - pt2.y;
        B = pt2.x - pt1.x;
        C = pt1.x * pt2.y - pt1.y * pt2.x;
        frac Div(A * A + B * B);
        Div.a = sqrtl(Div.a);
        Div.b = sqrtl(Div.b);
        A = A / Div;
        B = B / Div;
        C = C / Div;
    };
};

frac Det(frac a11 , frac a12 , frac a21 , frac a22)
{
    return a11 * a22 - a12 * a21;
}

bool IsParallel(line L1 , line L2)
{
    return Det(L1.A , L1.B , L2.A , L2.B) == frac(0);
}

frac PointLineDistance(line L , point Pt)
{
    frac Answer(Pt.x * L.A + Pt.y * L.B + L.C);
    Answer.a = abs(Answer.a);
    return Answer;
}

frac LineDistance(line L1 , line L2)
{
    if ( !(L2.B == frac(0)) )
        return PointLineDistance(L1 , point(frac(0) , frac(-1) * L2.C / L2.B));
    else
        return PointLineDistance(L1 , point(frac(-1) * L2.C / L2.A , frac(0)));
}

point Intersect(line L1 , line L2)
{
    point Answer;
    Answer.x = frac(-1) * Det(L1.C , L1.B , L2.C , L2.B) / Det(L1.A , L1.B , L2.A , L2.B);
    Answer.y = frac(-1) * Det(L1.A , L1.C , L2.A , L2.C) / Det(L1.A , L1.B , L2.A , L2.B);
    return Answer;
}

int K;
point A[32 * 32];
line L[32];
frac Dist[32 * 32];
vector <int> answer_id;

int main()
{
    freopen("motel.in","r",stdin);
    freopen("motel.out","w",stdout);
    int N;
    scanf("%d",&N);
    for (int i = 0 ; i < N ; i ++ )
    {
        int a , b , c , d;
        scanf("%d %d %d %d",&a,&b,&c,&d);
        L[i] = line(point(frac(a) , frac(b)),point(frac(c) , frac(d)));
    };
    bool AllParallel = true;
    for (int i = 1 ; i < N ; i ++ )
        if ( !IsParallel(L[0] , L[i]) )
        {
            AllParallel = false;
            break;
        };
    if ( AllParallel )
    {
        for (int i = 0 ; i < N ; i ++ )
            for (int j = 0 ; j < N ; j ++ )
                Dist[i] = Dist[i] + LineDistance(L[i] , L[j]);
        answer_id.push_back(0);
        for (int i = 1 ; i < N ; i ++ )
        {
            if ( Dist[answer_id.back()] == Dist[i] )
                answer_id.push_back(i);
            if ( Dist[answer_id.back()] > Dist[i] )
            {
                answer_id.clear();
                answer_id.push_back(i);
            }
        }
        for (int i = 0 ; i < answer_id.size() ; i ++ )
        {
            int id = answer_id[i];
            int Mul = L[id].A.b * L[id].B.b * L[id].C.b;
            L[id].A = L[id].A * frac(Mul);
            L[id].B = L[id].B * frac(Mul);
            L[id].C = L[id].C * frac(Mul);
            Mul = gcd(abs(L[id].A.a) , abs(L[id].B.a));
            Mul = gcd(Mul , abs(L[id].C.a));
            L[id].A = L[id].A / Mul;
            L[id].B = L[id].B / Mul;
            L[id].C = L[id].C / Mul;
            if ( L[id].A.a < 0 )
                L[id].A.a *= -1 , L[id].B.a *= -1 , L[id].C.a *= -1;
            if ( L[id].A.a == 0 && L[id].B.a < 0 )
                L[id].B.a *= -1 , L[id].C.a *= -1;
        }
        print(Dist[answer_id.back()]); printf("\n");
        printf("%d\n",-answer_id.size());
        for (int i = 0 ; i < answer_id.size() ; i ++ )
        {
            print(L[answer_id[i]].A);printf(" ");
            print(L[answer_id[i]].B);printf(" ");
            print(L[answer_id[i]].C);printf("\n");
        }
    } else
    {
        for (int i = 0 ; i < N ; i ++ )
            for (int j = i + 1 ; j < N ; j ++ )
            if ( !IsParallel(L[i] , L[j]) )
                A[K++] = Intersect(L[i] , L[j]);
        for (int i = 0 ; i < K ; i ++ )
            for (int j = 0 ; j < N ; j ++ )
                Dist[i] = Dist[i] + PointLineDistance(L[j] , A[i]);
        answer_id.push_back(0);
        for (int i = 1 ; i < K ; i ++ )
        {
            if ( Dist[answer_id.back()] == Dist[i] )
                answer_id.push_back(i);
            if ( Dist[answer_id.back()] > Dist[i] )
            {
                answer_id.clear();
                answer_id.push_back(i);
            }
        };
        print(Dist[answer_id.back()]); printf("\n");
        printf("%d\n",answer_id.size());
        for (int i = 0 ; i < answer_id.size() ; i ++ )
        {
            print(A[answer_id[i]].x);printf(" ");
            print(A[answer_id[i]].y);printf("\n");
        }
    }
    return 0;
}
