/* GCC */
#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <queue>
#include <algorithm>
#include <string>

using namespace std;

struct figure
{
    int cell_cnt , MinX , MinY , MaxX , MaxY ;
    vector <pair <int , int> > Coords;
    figure():MinX(2e9) , MinY(2e9){};
    unsigned long long Hash[8];
} Figure[250];

void TransformCoord(int id , int type)
{
    if ( !type )
        return;
    for (int j = 0 ; j < Figure[id].cell_cnt ; j ++ )
        {
            if ( type == 1 )
                Figure[id].Coords[j].first = Figure[id].MaxX - Figure[id].Coords[j].first;
            if ( type == 2 )
                Figure[id].Coords[j].second = Figure[id].MaxY - Figure[id].Coords[j].second;
            if ( type == 3 )
                Figure[id].Coords[j] = make_pair(Figure[id].MaxX - Figure[id].Coords[j].first ,
                                                       Figure[id].MaxY - Figure[id].Coords[j].second);
            if ( type == 4 )
                Figure[id].Coords[j] = make_pair(Figure[id].Coords[j].second ,
                                                       Figure[id].Coords[j].first);
            if ( type == 5 )
                Figure[id].Coords[j] = make_pair(Figure[id].MaxY - Figure[id].Coords[j].second ,
                                                       Figure[id].Coords[j].first);
            if ( type == 6 )
                Figure[id].Coords[j] = make_pair(Figure[id].Coords[j].second ,
                                                       Figure[id].MaxX - Figure[id].Coords[j].first);
            if ( type == 7 )
                Figure[id].Coords[j] = make_pair(Figure[id].MaxY - Figure[id].Coords[j].second ,
                                                       Figure[id].MaxX - Figure[id].Coords[j].first);

        }
}


int Go[4][2] = { {0 , 1} , {0 , -1} , {1 , 0} , {-1 , 0} };
int N , FigureCnt , Color[550] , Size[550] , SameCnt;
char A[550][550];

void PrepareFigure(int id)
{
    for (int i = 0 ; i < Figure[id].cell_cnt ; i ++ )
    {
        Figure[id].Coords[i].first -= Figure[id].MinX;
        Figure[id].Coords[i].second -= Figure[id].MinY;
    }
    Figure[id].MaxX -= Figure[id].MinX;
    Figure[id].MaxY -= Figure[id].MinY;
    for (int i = 0 ; i < 8 ; i ++ )
    {
        TransformCoord(id , i);
        sort(Figure[id].Coords.begin() , Figure[id].Coords.end());
        for (int j = 0 ; j < Figure[id].cell_cnt ; j ++ )
        Figure[id].Hash[i] = Figure[id].Hash[i] * 101
            + Figure[id].Coords[j].first * N + Figure[id].Coords[j].second + 1;
        TransformCoord(id , i);
    }
}

int get_root(int v)
{
    if ( Color[v] == v )
        return v;
    return Color[v] = get_root(Color[v]);
}

void unite(int v , int u)
{
    v = get_root(v);
    u = get_root(u);
    if ( Size[v] < Size[u] )
        swap(v , u);
    Size[v] += Size[u];
    Color[u] = Color[v];
}

bool ProbablySame(int i , int j)
{
    if ( get_root(i) == get_root(j))
        return false;
    if ( Figure[i].cell_cnt != Figure[j].cell_cnt )
        return false;
    if ( (Figure[i].MaxX == Figure[j].MaxX && Figure[i].MaxY == Figure[j].MaxY) || (Figure[i].MaxX == Figure[j].MaxY && Figure[i].MaxY == Figure[j].MaxX))
        return true;
}

bool Check(int id_1 , int id_2)
{
    for (int i = 0 ; i < 8 ; i ++ )
        for (int j = 0 ; j < 8 ; j ++ )
        if ( Figure[id_1].Hash[i] == Figure[id_2].Hash[j] )
        return true;
    return false;
}

int main()
{
    freopen("test.in","r",stdin);
    freopen("test.out","w",stdout);
    scanf("%d\n",&N);
    for (int i = 0 ; i < N ; i ++ )
        gets(A[i]);
    for (int i = 0 ; i < N ; i ++ )
        for (int j = 0 ; j < N ; j ++ )
        if ( A[i][j] == '*' )
        {
            queue <pair <int , int> > Q;
            Q.push(make_pair(i , j));
            A[i][j] = '.';
            while ( !Q.empty() )
            {
                int cur_x = Q.front().first;
                int cur_y = Q.front().second;
                Figure[FigureCnt].cell_cnt ++ ;
                Figure[FigureCnt].Coords.push_back(make_pair(cur_x , cur_y));
                Figure[FigureCnt].MaxX = max(Figure[FigureCnt].MaxX , cur_x);
                Figure[FigureCnt].MaxY = max(Figure[FigureCnt].MaxY , cur_y);
                Figure[FigureCnt].MinX = min(Figure[FigureCnt].MinX , cur_x);
                Figure[FigureCnt].MinY = min(Figure[FigureCnt].MinY , cur_y);
                Q.pop();
                for (int k = 0 ; k < 4 ; k ++ )
                {
                    int next_x = cur_x + Go[k][0];
                    int next_y = cur_y + Go[k][1];
                    if ( next_x >= 0 && next_y >= 0 && A[next_x][next_y] == '*' )
                    {
                        A[next_x][next_y] = '.';
                        Q.push(make_pair(next_x , next_y));
                    }
                }
            }
            PrepareFigure(FigureCnt);
            FigureCnt ++ ;
        };

    for (int i = 0 ; i < FigureCnt ; i ++ )
        Color[i] = i , Size[i] = 1;

    for (int i = 0 ; i < FigureCnt ; i ++ )
        for (int j = i + 1 ; j < FigureCnt ; j ++ )
        if ( ProbablySame(i , j) && Check(i , j) )
        {
            unite(i , j);
            SameCnt ++ ;
        }
    printf("%d %d\n",FigureCnt , FigureCnt - SameCnt);
    return 0;
}
