/* GCC */
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

const int dx[] = {1, -1, 0, 0};
const int dy[] = {0, 0, 1, -1};
int n, m = 0;
bool field[528][528];
struct figure{
  int x, y, mx;
  bool fig[528][1056];
};
struct rfigure{
  int x, y;
  bool fig[528][528];
};
vector<rfigure> marked;

void printFigure(const rfigure &a){
     for(int i = 0; i <= a.y+2; i++){
       for(int j = 0; j <= a.x+2; j++){
         cout<<a.fig[i][j];  
       }
       cout<<endl;
     }
     cout<<endl;
}

rfigure rotateRight(const rfigure &a){
     rfigure b;
     b.x = a.y; b.y = a.x;
     for(int i = 0; i <= a.y; i++)
       for(int j = 0; j <= a.x; j++)
         b.fig[j][a.y-i] = a.fig[i][j];    
     return b;
}

rfigure horSym(const rfigure &a){
     rfigure b;
     b.x = a.x; b.y = a.y;
     for(int i = 0; i <= a.y; i++)
       for(int j = 0; j <= a.x; j++)
         b.fig[a.y-i][j] = a.fig[i][j];
     return b;
}

rfigure verSym(const rfigure &a){
     rfigure b;
     b.x = a.x; b.y = a.y;
     for(int i = 0; i <= a.y; i++)
       for(int j = 0; j <= a.x; j++)
         b.fig[i][a.x-j] = a.fig[i][j];
     return b;
}

bool compare(const rfigure &a, const rfigure &b){
     for(int i = 0; i <= a.y; i++){
       for(int j = 0; j <= a.x; j++){
         if (a.fig[i][j] != b.fig[i][j]) return false;
       }
     }
     return true;
}

void addFig(figure fig){ 
     rfigure rfig; m++;
     for(int i = 0; i <= fig.y; i++) for(int j = fig.x; j <= fig.mx; j++) rfig.fig[i][j-fig.x] = fig.fig[i][j];
     rfig.x = fig.mx-fig.x;
     rfig.y = fig.y;
     for(int i = 0; i < marked.size(); i++){
            if (marked[i].x == rfig.x && marked[i].y == rfig.y){
                if( compare(marked[i], rfig)) return;
                if( compare(marked[i], verSym(rfig))) return;
                if( compare(marked[i], horSym(rfig))) return;
                rfig = verSym(rfig);
                if( compare(marked[i], horSym(rfig))) return;
            }
            if (marked[i].x == rfig.y && marked[i].y == rfig.x){
                rfig = rotateRight(rfig);
                if( compare(marked[i], rfig)) return;
                if( compare(marked[i], verSym(rfig))) return;
                if( compare(marked[i], horSym(rfig))) return;
                rfig = verSym(rfig);
                if( compare(marked[i], horSym(rfig))) return;              
            }
     }
     marked.push_back(rfig);
}

bool isFine(int i, int j){
     if ((i < 0) || i >= n) return false;
     if ((j < 0) || j >= n) return false;
     return true;
}

void mark(int i, int j){
     figure fig;
     pair<int, int> c;
     queue< pair<int, int> > q;
     for(int t = 0; t < n; t++) for (int z = 0; z < 2*n; z++) fig.fig[t][z] = false;
     fig.fig[0][n] = true; fig.x = n; fig.mx = n; fig.y = 0;
     field[i][j] = false;
     q.push(make_pair(i, j));
     while (!q.empty()){
           c = q.front(); q.pop();
           for(int z = 0; z < 4; z++){
                   if ( isFine(c.first+dy[z], c.second+dx[z]) && field[c.first+dy[z]][c.second+dx[z]] ){
                       field[c.first+dy[z]][c.second+dx[z]] = false;
                       q.push(make_pair(c.first+dy[z], c.second+dx[z]));
                       fig.fig[c.first+dy[z]-i][n-j+c.second+dx[z]] = true;
                       fig.mx = max(n-j+c.second+dx[z], fig.mx);
                       fig.x = min(n-j+c.second+dx[z], fig.mx);
                       fig.y = max(c.first+dy[z]-i, fig.y);
                   }
           }
     }
     addFig(fig);
}

int main(){
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    cin>>n;
    char a[1000];
    cin.getline(a, n);
    for(int i = 0; i < n; i++){
      cin.getline(a, 1000);
      for(int j = 0; j < n; j++){
        field[i][j] = (a[j] != ' ');
      }
    }
    for(int i = 0; i < n; i++){
      for(int j = 0; j < n; j++){
          if (field[i][j]){
            mark(i, j);
          }
      }
    }
    cout<<m<<" "<<marked.size()<<endl;
}
